/**
 * @author v_wangyan
 */
function g(id) { 
	return document.getElementById(id);
}	
function randomInt (min, max) {
	return Math.floor(Math.random() * (max - min + 1) + min);
}
function jsonDecode(jsonString) {
	return (new Function("return " + jsonString))();
}
function show(id) {
	isShow(id, true);
}
function hide(id) {
	isShow(id, false);
}
function isShow(id, flag) {
	g(id).style.display = flag? 'block' : 'none';
}
function addClass(element, className) {
	element = g(element)||element;
    var classArray = className.split(/\s+/),
        result = element.className,
        classMatch = " " + result + " ",
        i = 0,
        l = classArray.length;

    for (; i < l; i++) {
         if ( classMatch.indexOf( " " + classArray[i] + " " ) < 0 ) {
             result += (result ? ' ' : '') + classArray[i];
         }
    }

    element.className = result;
}
function removeClass(element, className) {
	element = g(element)||element;

    var oldClasses = element.className.split(/\s+/),
        newClasses = className.split(/\s+/),
        lenOld,
        lenDel = newClasses.length,
        j,
        i = 0;
    for (; i < lenDel; ++i) {
        for(j = 0, lenOld = oldClasses.length; j < lenOld; ++j) {
            if (oldClasses[j] == newClasses[i]) {
            	oldClasses.splice(j, 1);
            	break;
            }
        }
    }
    element.className = oldClasses.join(' ');
}
function createElement (className) {
  var div = document.createElement('div');
  div.className = className;
  return div;
}
//获取参数
function execSync(order, param) {
	try {
		if (window.external.SyncRequest) {
			return window.external.SyncRequest(order,param);
		} 
	} catch (e) {
		return '';
	}
	return '';
}
//执行命令
function execOrder(order, key) {
	try {
		window.external.SyncRequest(order, key);
	} catch (e) {}
}
/**
 * 设置存储值
 */
function setConfig(key, value) {
    var globalData = getConfigData();
    globalData[key] = value;
    var str = '{';
    var sp = '';

    for (k in globalData) {
        if ('{' != str) {
            sp =',';
        }
        str += sp + '"' + k + '":"' + globalData[k] + '"';
    }

    str += '}';
    window.external.SyncRequest('saveConfig', str);
}
/**
 * 获取存储的值
 */
function getConfig(key) { 
    var globalData = getConfigData();
    if (globalData && typeof globalData[key] != 'undefined') { 
        return globalData[key];
    }

    return null;
}
function getConfigData() {
	if (window.external.SyncRequest) {
		var strJSON = window.external.SyncRequest('readConfig'); 
		strJSON= jsonDecode(strJSON);
		return strJSON;
	}  
    return null;
}
//给RD调用
function setButtonState(key, statu) {
	var status = skins.buttonstatus;
	var id = '';
	key = key || '0';
	id = status[key].id;
	statu =  statu || (g(id).getAttribute('statu') == '0' ? '1' : '0');		
	g(id).src = 'images/icon/' + status[key][statu];
	g(id).setAttribute ('statu', statu); 		
}
/**
 * 设置输入法状态  
 * 参数:0 (中英文切换)	返回值: 0 英文 1 中文;
 * 参数:1 (全半角切换)	返回值: 0 半角 1 全角; 
 * 参数:2 (中英文标点)	返回值: 0 英文标点 1 中文标点;
 * 参数:3 (软键盘)
 * 参数:4 (登录)			返回值: 0 未登录 1 已登录
 * 参数:5 (配置)
 */
function setIMEStatus() {
	setButtonState('0', getExecStatus('language', '0'));	
	setButtonState('1', getExecStatus('characters', '1'));	
	setButtonState('2', getExecStatus('punctuation', '2'));	
}
//获取RD数据status,null 时返回当前状态
function getExecStatus(id, key) { 
	var statu = execSync('getButtonState', key) || g(id).getAttribute('statu'); 
	return statu;
}	
//处理点击
function execMouseDown (e, rightClick, key) {
	//取消冒泡事件
	e.stopPropagation(); 
	
	var order = rightClick ? 'mouseRDown' : 'mouseLDown';
	execOrder(order, key);
}
//右键点击
function rightButton(id) {
	if (event.button == 2) {
		execMouseDown(event, true, id);
	}
}
//生成dom
function buildDomList(list, obj) {
	var dom = null;
	for (i = 0, len = list.length; i < len; i++) {
		dom = createElement(list[i]);
		obj.appendChild(dom);
	}
}
//设置速度
function setSpeed(walk, speed) {
	var element = null;		
	if (speed.length) {
		element = createElement(speed);
	} else {
		element = createElement(speed.className);						
		var item = speed.childNode;
		
		buildDomList(item, element);
	}
	walk.innerHTML = '';
	walk.appendChild(element);
}
//获取当前游戏名
function getGame() {
	return g('main').className.split(' ').pop();
}
//显示游戏选项
function toggleShowGames(id, elmId) {		
	g(id).onclick = function () {
		if (optionStatus) {
			hide(elmId);
			optionStatus = false;
		} else {
			show(elmId);
			optionStatus = true;
		}
		
	}
}


//生成有序数组
function getIndexArr(count) {
	var arr = [];
	for (var i = 0; i < count; i++) {
		arr[i] = i;
	}
	return arr;
}    
//打乱数组排序
function randomSort(a, b) {
    return Math.random()>.7 ? -1 : 1;//用Math.random()函数生成0~1之间的随机数与0.5比较，返回-1或1
}
//追加一组img
function appendImgList() {
	var list = skins[gameStadus].bgList1;
	//获取图片总数
	imgCount = skins[gameStadus].bgCount;
	//生成随机索引
	var indexArr = getIndexArr(imgCount);
	indexArr.sort(randomSort);
	
	var num = 0;    	
	var img = null;
	for (var i=0, len = indexArr.length; i< len; i++) {
		num = indexArr[i];
		img = document.createElement('img');
		img.width = list[num][imgWidth];
		img.src = 'images/' + gameStadus + '/' + list[num][imgName];
		boxObj.appendChild(img);    		
	}
}   
//移除第一组img 
function removeImgList(num) {
	var childNode = null;
	for (var i = 0; i < num; i++) {
		childNode = boxObj.children[0];
		boxObj.removeChild(childNode);
	}
}  
//滚动效果
function marqee() {
	totalWidth = boxObj.offsetWidth;
	boxObj.style.left = -left + 'px';  
	if (left*2 > boxObj.offsetWidth) {
		removeImgList(imgCount); 
		appendImgList();
		left = left - totalWidth/2;  
		boxObj.style.left = -left + 'px';		
		window.clearTimeout(scrollBox);
	} 
	left ++;
	  	
	scrollBox =window.setTimeout(marqee, scrollSpeed);
}
//重设滚动
function startMarqee() {		
	window.clearTimeout(scrollBox);
	boxObj.innerHTML = '';
	appendImgList();
	appendImgList();
	scrollBox =window.setTimeout(marqee, 1);    
}

